 
/*
   @06-07-2016
   @09-07-2016
   CW callsign generator for Arduino Uno
   Modified by PA3BNX Call PA3JFL
   With parameter Serial message 
   PTT trigger pin
   PTT transmissie output
   tone CW output 
   and CW key output
 */


#include "pitches.h"

// notes in the melody:
int melody[] = {
  NOTE_C4, NOTE_G3, NOTE_G3, NOTE_A3, NOTE_G3, 0, NOTE_B3, NOTE_C4
};

// note durations: 4 = quarter note, 8 = eighth note, etc.:
int noteDurations[] = {
  4, 8, 8, 4, 4, 4, 4, 4
};

//OutPut pins
const byte cPinCW=13;//CW key
const byte cPinCWtone=11; //Only allowed PWM 3,5,6,9,10,11
const byte cPinPTT=3; //PTT tx hold pin 
const byte cPinPTTm=4;


//Input pins
const byte cPinHi=8;//Hi play pin
const byte cPinMelody=9; //Melody play
const byte cPinTrigger=10;//Trigger Remember High = No trigger

//Integer
int freq;
int stripe;
int dot;
int space;
int separator;
int time;
int x;

void StartMessage()
{
 //Run this for easy StartUp messagwe
 Serial.println(F("Version 1.01"));
 Serial.print(F("Melody trigger pin="));
 Serial.println(cPinMelody);
 Serial.print(F("Hi trigger pin="));
 Serial.println(cPinHi);
 Serial.print(F("CW trigger pin="));
 Serial.println(cPinTrigger);
 Serial.print(F("Melody + Hi send pin="));
 Serial.println(cPinPTTm);
 Serial.print(F("PTT tx busy pin="));
 Serial.println(cPinPTT);
 Serial.print(F("CW key pin="));
 Serial.println(cPinCW);
 Serial.print(F("CW tone pin="));
 Serial.println(cPinCWtone);
 Serial.print(F("CW tone freq="));
 Serial.println(freq);
 Serial.print(F("Delay sec's="));
 int i=time/10;
 Serial.println(i);
}

void Melody()
{
  Serial.println(F("Melody"));
  digitalWrite(cPinPTTm,HIGH);
  digitalWrite(cPinPTT,HIGH);
  
  delay(50);
  for (int thisNote = 0; thisNote < 8; thisNote++) {

    // to calculate the note duration, take one second
    // divided by the note type.
    //e.g. quarter note = 1000 / 4, eighth note = 1000/8, etc.
    int noteDuration = 800 / noteDurations[thisNote];
    tone(cPinCWtone, melody[thisNote], noteDuration);

    // to distinguish the notes, set a minimum time between them.
    // the note's duration + 30% seems to work well:
    int pauseBetweenNotes = noteDuration * 1.30;
    delay(pauseBetweenNotes);
    // stop the tone playing:
    noTone(cPinCWtone);
  }
  digitalWrite(cPinPTT,LOW);
  digitalWrite(cPinPTTm,LOW);
}


//Programs


void Leader()// 3 x v sein
{
  int f=freq;
  for (int i=0;i<3;i++)
  {
  switch(i){
   case 0:
  freq=f+600;
  break;
   case 1:
  freq=f+300;
  break;
  case 2:
  freq=f;
  break;
 default:
  freq=f;
  } 
  Serial.print('v');
  sein(dot);
  sein(dot);
  sein(dot);
  freq-=200;
  sein(stripe);
  freq+=200;
  sein(space);
  }
  sein(separator);
  freq=f; 
}  

void Trailer()
{
int i;
for (i=-150;i<50;i+=10)
{
 if (i<0)
  {
   tone(cPinCWtone,freq+i,100);
  }
 else
 {
  tone(cPinCWtone,freq-i,100);
 }
 delay(35);
}
 
 sein(space);
 tone(cPinCWtone,freq,space);
 sein(space);

 sein(separator);

}

void Hi()
{
Serial.println(F("HI"));
digitalWrite(cPinPTTm,HIGH);
digitalWrite(cPinPTT,HIGH); 
delay(50);  
sein(dot);
sein(dot);
sein(dot);
sein(dot);
sein(space);
sein(dot);
sein(dot);
sein(separator);
digitalWrite(cPinPTT,LOW);
digitalWrite(cPinPTTm,LOW);
}

void Callsign(bool b)
{

 if (b==true) {digitalWrite(cPinPTTm,HIGH);} 
 digitalWrite(cPinPTT,HIGH); 


x += 1;
digitalWrite(cPinPTT,HIGH);//Switch PTT on
Serial.print (x);
Serial.print(' ');
delay(dot);


Leader();
  
  //p 
Serial.print(F(" p"));
sein(dot);
sein(stripe);
sein(stripe);
sein(dot);
sein(space);

//a
Serial.print('a');
sein(dot);
sein(stripe);
sein(space); 

//3
Serial.print('3');
sein(dot);
sein(dot);
sein(dot);
sein(stripe);
sein(stripe);
sein(space);

//b
Serial.print('b');
sein(stripe);
sein(dot);
sein(dot);
sein(dot);
sein (space);

//n
Serial.print('n');
sein(stripe);
sein(dot);
sein(space);

//x
Serial.println('x');
sein(stripe);
sein(dot);
sein(dot);
sein(stripe);
sein(separator);

Trailer();

digitalWrite(cPinPTT,LOW);
if (b==true){digitalWrite(cPinPTTm,LOW);}  
}//Last Callsign

void Speed(int s)
{
  dot=s;
  stripe=3 * dot;
  space=4 * dot;
  separator=6 * dot;
}  

void sein(int token)
{
if (token==space)
{   
 delay(space);
 }
  else if (token==separator)
  {
  delay(separator);
  }  
  else
  {
  //freq= 200 + (analogRead(A0)* 2);
  digitalWrite(cPinCW,HIGH);
  tone(cPinCWtone,freq,token);
  delay(token);
  digitalWrite(cPinCW,LOW);
  delay(dot);
  }
 }

// Initialise
void setup() {
   Serial.begin(9600);
   //initialise port cPins
   pinMode(cPinCW, OUTPUT);
   pinMode(cPinPTT,OUTPUT);
   pinMode(cPinTrigger,INPUT_PULLUP);
   pinMode(cPinMelody,INPUT_PULLUP);
   pinMode(cPinHi,INPUT_PULLUP);
 
  Speed(60);
  freq = 750;
  time = 3000;  //1800* 100= 180000 = 180 Sec = 3 minutes 5 min
  StartMessage();
}

// start loop
void loop() {
 
//Now the delay ca 1800000mSec or 180Sec
//time * dot mSec
  for (int i=0;i<time;i++)
  {
   if (digitalRead(cPinMelody)==LOW){i=0;Melody();}
   if(digitalRead(cPinHi)==LOW){i=0;Hi();}  
   if (digitalRead(cPinTrigger)==LOW){i=0;Callsign(true);}
   delay(100);
  }
  Callsign(false);
} //end of loop
